/**
 * Swaps out the datepicker with date fields.
 */
(function ($) {
if ($(window).width() < 768) {
  Drupal.behaviors.date_popup = {
    attach: function (context) {
      var dateFields = {};
      for (var id in Drupal.settings.datePopup) {
        if (Drupal.settings.datePopup[id].func !== 'datepicker') {
          continue;
        }

        var $input = $('#' + id);
        var initialDate = $input.val();
        if (initialDate) {
          var timestamp = Date.parse(initialDate);
          $input.val($.datepicker.formatDate('yy-mm-dd', new Date(timestamp)));
        }
        $input[0].type = 'date'; // Can't use .attr() because jQuery doesn't allow you to change "type".

        var $parentForm = $input.parents('form');
        if (!$parentForm.hasClass('mobile-popup-processed')) {
          $parentForm.addClass('mobile-popup-processed');

          $parentForm.submit(function () {
            for (var thisId in Drupal.settings.datePopup) {
              var $thisInput = $('#' + thisId);
              if ($thisInput[0].type !== 'date' || Drupal.settings.datePopup[thisId].func !== 'datepicker') {
                continue;
              }

              var format = Drupal.settings.datePopup[thisId].settings.dateFormat;

              var formattedDate;
              if ($thisInput.val()) {
                var dateParts = $thisInput.val().split('-');
                if (dateParts.length === 1) {
                  formattedDate = $thisInput.val();
                } else {
                  var year = parseInt(dateParts[0]);
                  var month = parseInt(dateParts[1]);
                  var day = parseInt(dateParts[2]);
                  formattedDate = $.datepicker.formatDate(format, new Date(year, month - 1, day));
                }
              } else {
                formattedDate = '';
              }

              $thisInput[0].type = 'text';
              $thisInput.val(formattedDate);
            }
          });
        }
      }
    }
  }
}
})(jQuery);
